=== qt/tests/unit/oxideqcertificateerror/CMakeLists.txt ===
# vim:expandtab:shiftwidth=2:tabstop=2:

# Copyright (C) 2016 Canonical Ltd.

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Test REQUIRED)

add_executable(tst_oxideqcertificateerror tst_oxideqcertificateerror.cc)
target_link_libraries(tst_oxideqcertificateerror
                      PRIVATE ${OXIDE_LIB} Qt5::Core Qt5::Gui Qt5::Test)
set_target_properties(tst_oxideqcertificateerror PROPERTIES
                      AUTOMOC TRUE)

add_test(NAME tst_oxideqcertificaterror
         COMMAND ${OXIDE_BIN_OUTPUT_DIR}/run_qmlapp.sh
                 ${CMAKE_CURRENT_BINARY_DIR}/tst_oxideqcertificateerror)
